require 'thor'
require 'misfortune/cli/random_command'
require 'misfortune/cli/binge_command'
require 'misfortune/cli/credits_command'

module Misfortune
  module CLI
    class Runner < Thor
      def self.flavors
        Misfortune::Flavor::FLAVORS_MAP.keys.join(', ')
      end

      default_task :random

      class_option :source, type: :string, desc: 'Source markdown file'

      desc 'random', 'Prints a random cookie.'
      method_option :flavor,
                    type: :string,
                    default: :terminal,
                    desc: "Select output flavor. Available options: #{flavors}"

      def random
        RandomCommand.new(options).run
      end

      desc 'binge', 'Non-stop cookies'

      def binge
        BingeCommand.new(options).run
      end

      desc 'credits', 'Credits'

      def credits
        CreditsCommand.new(options).run
      end
    end
  end
end
