module Misfortune
  class CookieJar
    attr_reader :file

    def initialize(file = nil)
      @file = file || data_file_path('source')
    end

    def cookies
      @cookies ||= file_chunks
    end

    protected

    def file_chunks
      File.read(file)
        .split(/\n#\s/)
        .map(&:strip)
        .reject(&:empty?)
        .map { |chunk| chunk.prepend '#' }
    end

    def data_file_path(name)
      File.join(File.dirname(__FILE__), '..', '..', 'data', "#{name}.md")
    end
  end
end
