module Misfortune
  class Flavor
    FLAVORS_MAP = {
      html: Redcarpet::Render::HTML,
      vanilla: Redcarpet::Render::StripDown,
      terminal: Misfortune::Render::Terminal
    }.freeze

    REDCARPET_OPTIONS = {
      fenced_code_blocks: true,
      strikethrough: true,
      autolink: true
    }.freeze

    attr_reader :markdown

    def initialize(kind)
      @markdown = Redcarpet::Markdown.new(
        FLAVORS_MAP.fetch(kind.to_sym),
        REDCARPET_OPTIONS
      )
    end

    def apply_to(cookie)
      markdown.render(cookie).chomp
    end
  end
end
